# SourcePath: glibc-2.11.2/20110822
Summary: The GNU C Library.
Name: sony-target-dev-glibc-libpthread_ptt
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-glibc-libpthread_ptt
Version: 2.11.2
Release: 08000103
License: LGPL2.1 / Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.gnu.org/software/libc
Source0: glibc-%{version}.tar.bz2
Source1: glibc-ports-2.11.tar.bz2

## LOT script Files
Source10: sony-devel-libopt-build-libc
Source11: sony-devel-libopt-build-libcrypt
Source12: sony-devel-libopt-build-libdl
Source13: sony-devel-libopt-build-libm
Source14: sony-devel-libopt-build-libpthread
Source15: sony-devel-libopt-build-librt

# Patches 
# Linux From Scratch patches: http://trac.cross-lfs.org/browser/trunk/patches 
Patch001: glibc-%{version}-libgcc_eh-1.patch
Patch002: glibc-%{version}-localedef_segfault-1.patch

# arm patches
Patch200: glibc-2.11.2-Move-ARM-EABI-mcount-into-a-separate-S-file.patch
Patch201: glibc-2.11.2-Add-CFI-statements-to-ARMs-assembly-code.patch
Patch202: glibc-2.11.2-Fix-unwinding-through-Thumb-2-system-calls.patch
Patch203: glibc-2.11.2-arm-longjmp_chk-unwinding-support.patch
Patch204: glibc-ports-2.11-mcount_gprof_fix.patch

# General patches ( patches added to glibc-2.5 for CE-4.X & CE-3.X)
Patch300: glibc-2.7-getcwd-max-def.patch

## Sony SS Original
## Make fatal error warn when using the wrong kernel version
Patch301: glibc-%{version}-rtld-osinfo-nonfatal.patch

## hp-timing support
Patch302: glibc-%{version}-hp-timing-ctors.patch
Patch303: glibc-%{version}-nptl-cond_timedwait_rel.patch

## sprof
Patch304: glibc-%{version}-sprof.patch

# Sony SS Original
# Change default timeout from 2 sec to 200 sec for testing
Patch305: glibc-2.7-change-default-for-testing.patch


Patch401: glibc-2.11.2-pr6812.patch
Patch402: glibc-2.11.2-pr7066.patch
Patch403: glibc-2.11.2-pr10401.patch
Patch404: glibc-2.11.2-pr10939.patch
Patch405: glibc-2.11.2-pr10992.patch
Patch406: glibc-2.11.2-pr11056.patch
Patch407: glibc-2.11.2-pr11093.patch
Patch408: glibc-2.11.2-pr11134.patch
Patch409: glibc-2.11.2-pr11141.patch
Patch410: glibc-2.11.2-pr11185.patch
Patch411: glibc-2.11.2-pr11186.patch
Patch412: glibc-2.11.2-pr11187.patch
Patch413: glibc-2.11.2-pr11188.patch
Patch414: glibc-2.11.2-pr11189.patch
Patch415: glibc-2.11.2-pr11190.patch
Patch416: glibc-2.11.2-pr11191.patch
Patch417: glibc-2.11.2-pr11192.patch
Patch418: glibc-2.11.2-pr11193.patch
Patch419: glibc-2.11.2-pr11235.patch
Patch420: glibc-2.11.2-pr11276.patch
Patch421: glibc-2.11.2-pr11389.patch
Patch422: glibc-2.11.2-pr11394.patch
Patch423: glibc-2.11.2-pr11611.patch
Patch424: glibc-2.11.2-pr11655.patch
Patch425: glibc-2.11.2-pr11701.patch
Patch426: glibc-2.11.2-pr11724_dep.patch
Patch427: glibc-2.11.2-pr11724.patch
Patch428: glibc-2.11.2-pr11840.patch
Patch429: glibc-2.11.2-pr11883.patch
Patch430: glibc-2.11.2-pr11903_dep.patch
Patch431: glibc-2.11.2-pr11903.patch
Patch432: glibc-2.11.2-pr12005.patch
#Patch433: glibc-2.11.2-pr12037.patch (To fix build error)
Patch434: glibc-2.11.2-pr12078_one.patch
Patch435: glibc-2.11.2-pr12078_two.patch
Patch436: glibc-2.11.2-pr12078_three.patch
Patch437: glibc-2.11.2-pr12078_four.patch
Patch438: glibc-2.11.2-pr12092.patch
Patch439: glibc-2.11.2-pr12093.patch
Patch440: glibc-2.11.2-pr12107_dep.patch
Patch441: glibc-2.11.2-pr12107.patch
Patch442: glibc-2.11.2-pr12108.patch
Patch443: glibc-2.11.2-pr12140.patch
Patch444: glibc-2.11.2-pr12167.patch
Patch445: glibc-2.11.2-pr12201.patch
Patch446: glibc-2.11.2-pr12204.patch
Patch447: glibc-2.11.2-pr12348.patch
Patch448: glibc-2.11.2-pr12378.patch
Patch449: glibc-2.11.2-pr12394.patch
Patch450: glibc-2.11.2-pr12397.patch
Patch451: glibc-2.11.2-pr12454.patch

# Add PTT support.
Patch600: glibc-2.11.2-ptt.patch
Patch601: glibc-2.11.2-ptt-arm.patch
Patch602: glibc-2.11.2-ptt-fix-sem-post-out.patch
Patch603: glibc-2.11.2-ptt-sigqueue.patch

Patch700: glibc-2.11.2-CVE-2011-0536.patch
Patch701: glibc-2.11.2-CVE-2011-1071.patch
Patch702: glibc-2.11.2-CVE-2011-1095.patch

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}

#BuildRequires: %{sony_tool_triplet}-cross-libopt-for-dev

%description
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%package -n %{pkgname}
Summary: The GNU C Library.
Group: %{sony_group}
AutoReqProv: no


%description -n %{pkgname}
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%prep
%setup -q -n glibc-%{version} -q -a 1

# Apply patches
%patch001 -p1
%patch002 -p1

%patch200 -p1
%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1

%patch300 -p1
%patch301 -p1
%patch302 -p1
%patch303 -p1
%patch304 -p1
%patch305 -p1


%patch401 -p1
%patch402 -p1
%patch403 -p1
%patch404 -p1
%patch405 -p1
%patch406 -p1
%patch407 -p1
%patch408 -p1
%patch409 -p1
%patch410 -p1
%patch411 -p1
%patch412 -p1
%patch413 -p1
%patch414 -p1
%patch415 -p1
%patch416 -p1
%patch417 -p1
%patch418 -p1
%patch419 -p1
%patch420 -p1
%patch421 -p1
%patch422 -p1
%patch423 -p1
%patch424 -p1
%patch425 -p1
%patch426 -p1
%patch427 -p1
%patch428 -p1
%patch429 -p1
%patch430 -p1
%patch431 -p1
%patch432 -p1
%patch434 -p1
%patch435 -p1
%patch436 -p1
%patch437 -p1
%patch438 -p1
%patch439 -p1
%patch440 -p1
%patch441 -p1
%patch442 -p1
%patch443 -p1
%patch444 -p1
%patch445 -p1
%patch446 -p1
%patch447 -p1
%patch448 -p1
%patch449 -p1
%patch450 -p1
%patch451 -p1

%patch600 -p1
%if %{sony_target_cpu} == "arm"
%patch601 -p1
%endif
%patch602 -p1
%patch603 -p1

%patch700 -p1
%patch701 -p1
%patch702 -p1
#
# NOTE: Build with nptl, with TLS
#
%build
%sony_target_dev_setup

%define _header_dir %{sony_target_dir}%{sony_target_dev_include_dir}

# compile option for EX project
# ARM work around for glibc build break and gcc Nested Function bug.
%if "%{sony_target_cpu}" == "arm"
export CFLAGS="-O2 -g -fno-omit-frame-pointer -funwind-tables"
%else
export CFLAGS="-O2 -g -fno-omit-frame-pointer "
%endif

# autoconf cause "checking for grep that handles long lines and -e"
# failure, config.log msg: error: no acceptable grep could be found
#autoconf &&
%if "%{sony_target_cpu}" == "ppc"
   export libc_cv_ppc_machine=yes \
	  libc_cv_ppc_rel16=no \
%endif
# to build nptl
export libc_cv_forced_unwind=yes
export libc_cv_c_cleanup=yes
export libc_cv_gnu99_inline=yes

# build libpthread library for PTT.
export BUILD_CC="gcc"
%sony_target_dev_configure \
	--disable-sanity-checks \
	--enable-add-ons=glibc-ports-2.11,nptl \
	--enable-kernel=2.6.29 \
	--enable-profile \
	--without-cvs \
%if "%{sony_target_fpu}" == "no"
	--without-fp \
%endif
	--with-tls \
	--with-__thread \
	--without-gd \
        --with-ptt \
	--with-headers=%{_header_dir} &&
cat <<EOF > configparms &&
slibdir=%{sony_target_dev_dir}/lib
sysconfdir=%{sony_target_dev_dir}/etc
EOF
make OBJDUMP_FOR_HOST=%{sony_target_toolprefix}objdump all

mv nptl/{libpthread.so,libpthread_ptt-%{version}.so}

%install
%sony_target_dev_setup

rm -rf %{buildroot}
%define _libdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}

mkdir -p %{_libdir}
cd %{sony_objdir}
install -m 755 nptl/libpthread_ptt-%{version}.so  %{_libdir}
(cd %{_libdir} ; ln -s libpthread_ptt-%{version}.so libpthread_ptt.so.0)

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt.so.0
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt-%{version}.so

%changelog
* Mon Aug 22 2011 Sony Corporation
- CVE-2011-0536, CVE-2011-1071 and CVE-2011-1095 security fix patches are added.

* Fri Mar 31 2011 Sony Corporation
- PR12454 patch is added.

* Fri Mar 11 2011 Sony Corporation
- Glibc information tables patches as on 2011-02-17

* Fri Mar 11 2011 Sony Corporation
- Add cfi statements to gprof patch

* Thu Mar 10 2011 Sony Corporation
- Thumb2 stabilization patches are added.
- -funwind-tables option is added by default for ARM.
- glibc-ports-2.11-mcount_gprof_fix.patch is removed temporary
  because of dependency.

* Thu Mar 10 2011 Sony Corporation
- CE-6.X glibc patch merging.

* Mon Feb 21 2011 Sony Corporation
- Added PTT support for glibc-2.11.2 version.
- Added patch to trace pthread_sigqueue API.

* Fri Dec 31 2010 Sony Corporation
- Patch to fix gprof Segmentation Fault

* Wed Aug 25 2010 Sony Corporation
- Initial build.
